<?php

class swypeCrossfitHelper {

    static function is_administrator() {
        $user = JFactory::getUser();
        return $user->authorise('core.admin');
    }

    static function get_debugged_user() {

        $session = JFactory::getSession();

        if (JRequest::getVar("idUserDebug") == "false") {
            $session->set('crossfit.user', null);
            return false;
        } elseif (JRequest::getVar("idUserDebug")) {
            $session->set('crossfit.user', JRequest::getVar("idUserDebug"));
            return JRequest::getVar("idUserDebug");
        } elseif ($session->get('crossfit.user')) {
            return $session->get('crossfit.user');
        }
    }

    static function get_next_subscription() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }

        $query->select("X.*, DATE_ADD( DATE_ADD( DATE_ADD( dataInizio, INTERVAL mesi MONTH ), INTERVAL giorniAggiuntivi DAY), INTERVAL giorniSospensione DAY) dataScadenzaAbbonamento ")
                ->from('#__crossfit_subscriptions_users X')
                ->innerJoin($dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription')
                ->innerJoin($dbo->qn('#__crossfit_users') . ' U ON U.idUser = X.idUser')
                ->where($dbo->qn('idUserJoomla') . ' = ' . $user->get('id'))
                ->where("X.dataInizio > NOW()");

        return $dbo->setQuery($query, 0, 1)->loadObject();
    }

    public static function getLocation() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("id, name")->from("#__rseventspro_locations")->order("name");
        $db->setQuery($query);
        $objectList = $db->loadObjectList();

        $places = array();
        if ($objectList) {
            foreach ($objectList as $row) {
                $places[$row->id] = $row->name;
            }
        }

        return $places;
    }

    static function getcfuserdata($iduser = null) {

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        if ($iduser != null) {
            $user = JFactory::getUser($iduser);
        } elseif (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }

        $id = JFactory::getApplication()->input->get('id');
        if (strpos($id, "-") !== false) {
            $list = explode("-", $id);
        } else {
            $list = explode(":", $id);
        }
        $EventID = $list[0];

        if (JRequest::getVar("option") == 'com_rseventspro' && JRequest::getVar("view") == 'calendar') {
            if (JRequest::getVar("date")) {
                $date = JRequest::getVar("date");
                list($m, $d, $y) = explode("-", $date);
                $date = "{$y}-{$m}-{$d}";
                if (date("W") == date("W", strtotime($date))) {
                    $date = date("Y") . "-" . date("m") . "-" . date("d");
                }
            } else {
                $date = date("Y") . "-" . date("m") . "-" . date("d");
            }
        } else if (JRequest::getVar("option") == 'com_rseventspro' && JRequest::getVar("layout") == 'show') {
            $date = self::get_event_start_date($EventID);
        } else if (JRequest::getVar("option") == 'com_rseventspro' && JRequest::getVar("layout") == 'subscribe') {
            $date = self::get_event_start_date($EventID);
        } else {
            $date = date("Y") . "-" . date("m") . "-" . date("d");
        }

        $query->select("*, DATE_ADD(dataCertificato, INTERVAL 1 YEAR) as dataScadenzaCertificato")
                ->select('(
                SELECT dataScadenzaReale
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as dataScadenzaReale')
                ->select('(
                SELECT adIngressiTotali
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as adIngressiTotali')
                ->select('(
                SELECT ad_ingressi
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as ad_ingressi')
                ->select('(
                SELECT idSU
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as idSU')
                ->select('(
                SELECT ingressi
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as ingressi')
                ->select('(
                SELECT ingressiGiornalieri
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as ingressiGiornalieri')
                ->select('(
                SELECT ingressiTotali
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as ingressiTotali')
                ->select('(
                SELECT DATE_ADD( DATE_ADD( DATE_ADD( dataInizio, INTERVAL mesi MONTH ), INTERVAL giorniAggiuntivi DAY), INTERVAL giorniSospensione DAY) dataScadenzaAbbonamento 
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as dataScadenzaAbbonamento')
                ->select('(
                SELECT dataInizio
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as dataInizioAbbonamento')
                ->select('(
                SELECT sospeso
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as abbonamentoSospeso')
                ->select('(
                SELECT sospeso
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as abbonamentoSospeso')
                ->select('(
                SELECT allenamentoAggiuntivo 
                FROM ' . $dbo->quoteName('#__crossfit_subscriptions_users') . ' X
                    INNER JOIN ' . $dbo->quoteName('#__crossfit_subscriptions') . ' Y ON Y.idSubscription = X.idSubscription
                WHERE X.idUser = U.idUser AND X.dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as allenamentoAggiuntivo')
                ->select('(
                SELECT DATE_ADD( dataInizio, INTERVAL durata YEAR ) dataScadenzaIscrizione 
                FROM ' . $dbo->quoteName('#__crossfit_memberships') . '
                WHERE idUser = U.idUser AND dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as dataScadenzaIscrizione')
                ->select('(
                SELECT dataInizio 
                FROM ' . $dbo->quoteName('#__crossfit_memberships') . '
                WHERE idUser = U.idUser AND dataInizio <= "' . $date . '"
                ORDER BY dataInizio DESC 
                LIMIT 0 , 1) as dataInizioIscrizione')
                ->from($dbo->qn('#__crossfit_users') . 'AS U')
                ->where($dbo->qn('idUserJoomla') . ' = ' . $user->get('id'));

        $dbo->setQuery($query);

        $array = $dbo->loadObject();
        if (!$array) {
            return;
        }

        if ($array->dataScadenzaAbbonamento) {
            $array->dataScadenzaAbbonamento = $array->dataScadenzaAbbonamento . " 23:59:59";
        }
        if ($array->dataScadenzaReale) {
            $array->dataScadenzaReale = $array->dataScadenzaReale . " 23:59:59";
        }
        if ($array->dataScadenzaIscrizione) {
            $array->dataScadenzaIscrizione = $array->dataScadenzaIscrizione . " 23:59:59";
        }
        if ($array->dataScadenzaCertificato) {
            $array->dataScadenzaCertificato = $array->dataScadenzaCertificato . " 23:59:59";
        }
        if ($array->dataInizio) {
            $array->dataInizio = $array->dataInizio . " 23:59:59";
        }

        if (strtotime($array->dataScadenzaReale) > 0) {
            $array->dataScadenzaAbbonamento = $array->dataScadenzaReale;
        }

        if ($array->ad_ingressi) {

            $risultato = array();

            // Calcolo l'ADESSO
            $now = date("Y-m-d 23:59:59");
            if (JRequest::getVar("date") && JRequest::getVar("layout") == "week") {
                list($m, $g, $a) = explode("-", JRequest::getVar("date"));
                $now = date("{$a}-{$m}-{$g} 23:59:59");
            } else if (JRequest::getVar("id") && JRequest::getVar("layout") == "show") {
                $query = ""
                        . "SELECT start "
                        . "FROM #__rseventspro_events "
                        . "WHERE id = {$EventID}";

                $dbo->setQuery($query);
                $now = $dbo->loadResult();
                $now = date("Y-m-d 23:59:59", strtotime($now));
            }
            $risultato['questa-settimana']['settimana-numero'] = (int) date("W");

            // Capisco da che data partire
            if (strtotime($array->dataInizioAbbonamento) < strtotime("2017-04-03 00:00:00")) {
                $risultato['settimane-passate']['data-inizio'] = "2017-04-03 00:00:00";
            } elseif (date("w", strtotime($array->dataInizioAbbonamento)) == 0 || date("w", strtotime($array->dataInizioAbbonamento)) >= 4) {
                $risultato['settimane-passate']['data-inizio'] = date("Y-m-d 00:00:00", strtotime("next monday", strtotime($array->dataInizioAbbonamento)));
                $risultato['settimane-passate']['data-inizio-traslata'] = true;
            } else {
                $risultato['settimane-passate']['data-inizio'] = date("Y-m-d 00:00:00", strtotime($array->dataInizioAbbonamento));
            }
            $risultato['settimane-passate']['settimana-numero'] = (int) date("W", strtotime($risultato['settimane-passate']['data-inizio']));

            if ($risultato['questa-settimana']['settimana-numero'] == $risultato['settimane-passate']['settimana-numero']) {
                $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("next sunday"));
                $risultato['settimane-passate']['numero-settimane'] = 0;
            } else {
                if (date("w", time()) == 0) {
                    $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("- 1 weeks"));
                } else {
                    $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("last sunday"));
                }

                if (strtotime($risultato['settimane-passate']['data-fine']) > time()) {
                    $risultato['settimane-passate']['data-fine'] = date("Y-m-d 23:59:59", strtotime("last sunday"));
                }

                $start = new DateTime($risultato['settimane-passate']['data-inizio']);

                if (date("Y", strtotime($risultato['settimane-passate']['data-inizio'])) == date("Y", strtotime($risultato['settimane-passate']['data-fine']))) {
                    $end = new DateTime($risultato['settimane-passate']['data-fine']);
                    $interval = $end->diff($start);
                    $risultato['settimane-passate']['numero-settimane'] = ceil($interval->days / 7);
                } elseif (date("Y", strtotime($risultato['settimane-passate']['data-inizio'])) < date("Y", strtotime($risultato['settimane-passate']['data-fine']))) {
                    $end = new DateTime(date("Y", strtotime("last year")) . "-12-31 23:59:59");
                    $interval = $end->diff($start);
                    $risultato['settimane-passate']['numero-settimane'] = ceil($interval->days / 7);
                    $start1 = new DateTime(date("Y") . "-01-01 00:00:00");
                    $end1 = new DateTime($risultato['settimane-passate']['data-fine']);
                    $interval1 = $end1->diff($start1);
                    $risultato['settimane-passate']['numero-settimane'] += ceil($interval1->days / 7);
                } else {
                    $risultato['settimane-passate']['numero-settimane'] = 0;
                }
            }

            $risultato['settimane-passate']['ingressi-potenziali'] = $risultato['settimane-passate']['numero-settimane'] * $array->ingressi;
            $risultato['settimane-passate']['ingressi-effettuati'] = 0;

            // Conto i giorni nelle settimane passate in cui ho partecipato ad un corso
            $query = $dbo->getQuery(true);

            $query->select("U.idu, DATE(E.start) as date")
                    ->from("#__rseventspro_users as U")
                    ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                    ->where("E.start BETWEEN '{$risultato['settimane-passate']['data-inizio']}' AND '{$risultato['settimane-passate']['data-fine']}'")
                    ->where("U.idu = " . $user->get('id'))
                    ->group("U.idu, DATE(E.start)");

            if ($dbo->setQuery($query)->execute()) {
                $risultato['settimane-passate']['ingressi-effettuati'] = $dbo->getNumRows();
            } else {
                $risultato['settimane-passate']['ingressi-effettuati'] = 0;
            }
            $risultato['settimane-passate']['recuperi'] = $risultato['settimane-passate']['ingressi-potenziali'] - $risultato['settimane-passate']['ingressi-effettuati'];

            $query = "SELECT * FROM #__crossfit_subscriptions_sospensions WHERE closed = 1 AND startDate < endDate AND idSubscription = {$array->idSU}";
            $sospensioni = $dbo->setQuery($query)->loadObjectList();
            $weeksSospensione = 0;
            if ($sospensioni) {
                foreach ($sospensioni as $sospensione) {
                    $diff = floor((strtotime($sospensione->endDate) - strtotime($sospensione->startDate)) / (60 * 60 * 24));
                    $weeksSospensione += floor($diff / 6);
                }
            }
            if ($weeksSospensione) {
                $risultato['settimane-passate']['sospensioni']['settimane'] = $weeksSospensione;
                $risultato['settimane-passate']['sospensioni']['ingressi-da-stornare'] = $weeksSospensione * $array->ingressi;
                if ($risultato['settimane-passate']['recuperi']) {
                    $risultato['settimane-passate']['recuperi'] -= $risultato['settimane-passate']['sospensioni']['ingressi-da-stornare'];
                }
            }

            $risultato['settimane-future']['data-inizio'] = date("Y-m-d 00:00:00", strtotime("next monday", strtotime($risultato['settimane-passate']['data-fine'])));
            $risultato['settimane-future']['ingressi-effettuati'] = 0;

            // Conto i giorni nelle settimane passate in cui ho partecipato ad un corso
            $query = $dbo->getQuery(true);
            if ((int) $array->ingressiGiornalieri === 1) {
                $query->select("U.idu, E.start as date");
                $query->group("U.idu, E.start");
            } else {
                $query->select("U.idu, DATE(E.start) as date");
                $query->group("U.idu, DATE(E.start)");
            }
            $query->from("#__rseventspro_users as U")
                    ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                    ->where("E.start > '{$risultato['settimane-passate']['data-fine']}'")
                    ->where("U.idu = " . $user->get('id'));


            $lists = $dbo->setQuery($query)->loadObjectList();
            if ($lists) {
                foreach ($lists as $date) {
                    $arraySETT[date("W", strtotime($date->date))] += 1;
                    $risultato['settimane-future']['ingressi-effettuati'] += 1;
                }
            }
            if ($arraySETT) {
                foreach ($arraySETT as $sett) {
                    $risultato['settimane-future']['ingressi-effettuabili'] += $array->ingressi;
                }
            }
            if ($risultato['settimane-future']['ingressi-effettuati'] > $risultato['settimane-future']['ingressi-effettuabili']) {
                $risultato['settimane-future']['ingressi-recuperati'] = $risultato['settimane-future']['ingressi-effettuati'] - $risultato['settimane-future']['ingressi-effettuabili'];
            } else {
                $risultato['settimane-future']['ingressi-recuperati'] = 0;
            }
            $risultato['settimane-future']['ingressi-recuperabili'] = $risultato['settimane-passate']['recuperi'] - $risultato['settimane-future']['ingressi-recuperati'];


            if (date("N", strtotime($now)) != 1) {
                $risultato['questa-settimana']['data-inizio'] = strtotime("last monday", strtotime($now));
            } else {
                $risultato['questa-settimana']['data-inizio'] = strtotime($now);
            }
            if ($risultato['questa-settimana']['data-inizio'] <= strtotime($array->dataInizioAbbonamento)) {
                $risultato['questa-settimana']['data-inizio'] = strtotime($array->dataInizioAbbonamento);
            }
            $risultato['questa-settimana']['data-inizio'] = date("Y-m-d 00:00:00", $risultato['questa-settimana']['data-inizio']);
            $risultato['questa-settimana']['data-fine'] = date("Y-m-d 23:59:59", strtotime("next sunday", strtotime($risultato['questa-settimana']['data-inizio'])));

            $query = $dbo->getQuery(true);
            if ((int) $array->ingressiGiornalieri === 1) {
                $query->select("U.idu, E.start as date");
                $query->group("U.idu, E.start");
            } else {
                $query->select("U.idu, DATE(E.start) as date");
                $query->group("U.idu, DATE(E.start)");
            }
            $query->from("#__rseventspro_users as U")
                    ->innerJoin("#__rseventspro_events as E on E.id = U.ide")
                    ->where("E.start BETWEEN '{$risultato['questa-settimana']['data-inizio']}' AND '{$risultato['questa-settimana']['data-fine']}'")
                    ->where("U.idu = " . $user->get('id'));

            $dbo->setQuery($query)->execute();
            $risultato['questa-settimana']['ingressi-effettuati'] = $dbo->getNumRows();
            $risultato['questa-settimana']['ingressi-disponibili'] = $array->ingressi - $risultato['questa-settimana']['ingressi-effettuati'];

            $array->arrayIngressi = $risultato;
        } elseif ($array->adIngressiTotali) {

            $datainizio = $array->dataInizioAbbonamento;

            $query = ""
                    . "SELECT COUNT(*) "
                    . "FROM #__rseventspro_users "
                    . "WHERE date BETWEEN '{$datainizio}' AND NOW() AND idu = " . $user->get('id');

            $dbo->setQuery($query);
            $usati = $dbo->loadResult();

            $array->arrayIngressi = array(
                'usati' => $usati,
            );
        }

        return $array;
    }

    public function checkCertificato() {
        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }
        $cfuserdata = self::getcfuserdata();
        $secondsD = 60 * 60 * 24;
        $dIscrizione = $secondsD * DAYS_ISCRIZIONE;
        $dCertificato = $secondsD * DAYS_CERTIFICATO;
        if (!$cfuserdata->dataScadenzaCertificato && $cfuserdata->dataInizioAbbonamento) {
            if (time() <= (strtotime($cfuserdata->dataInizioAbbonamento) + $dCertificato)) {
                return true;
            }
        } elseif ($cfuserdata->dataScadenzaCertificato && time() <= strtotime($cfuserdata->dataScadenzaCertificato)) {
            return true;
        }
        return false;
    }

    public static function getEntrances() {
        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("ingressi")
                ->from($db->quoteName('#__crossfit_subscriptions_users') . " AS us")
                ->innerJoin($db->quoteName('#__crossfit_subscriptions') . " AS s ON s.idSubscription = us.idSubscription")
                ->innerJoin($db->quoteName('#__crossfit_users') . " AS u ON us.idUser = u.idUser")
                ->where($db->qn('idUserJoomla') . ' = ' . $user->get('id'))
                ->order("us.dataInizio DESC");

        $db->setQuery($query, 0, 1);

        return $db->loadResult();
    }

    public function getweeklyEntrances() {

        $date = JFactory::getApplication()->input->getString('date');
        $option = JFactory::getApplication()->input->getString('option');
        $layout = JFactory::getApplication()->input->getString('layout');
        $thisid = JFactory::getApplication()->input->getString('id');

        $db = JFactory::getDbo();
        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }
        $query = $db->getQuery(true);


        if ($option == "com_rseventspro" && $layout == "show") {
            $id = JFactory::getApplication()->input->get('id');
            if (strpos($id, "-") !== false) {
                $list = explode("-", $id);
            } else {
                $list = explode(":", $id);
            }
            $EventID = $list[0];
            $query->select("*")->from("#__rseventspro_events")->where("id = {$EventID}");
            $db->setQuery($query);
            $event = $db->loadObject();
            $query->clear();
            if ($event->start) {
                $date = date('m-d-Y', strtotime($event->start));
            }
        }

        if (!$date) {
            $date = date('m-d-Y', strtotime('this week', time()));
        }

        list($m, $d, $y) = explode('-', $date);

        $neededstart = date("Y-m-d 00:00:00", strtotime('this week', strtotime("{$y}-{$m}-{$d}")));
        $neededend = date("Y-m-d 23:59:59", strtotime('+6 days', strtotime($neededstart)));

        $query->select("COUNT(*)")
                ->from($db->quoteName('#__rseventspro_users') . " as u")
                ->innerJoin($db->quoteName('#__rseventspro_events') . " as e ON e.id = u.ide")
                ->where($db->qn('u.idu') . ' = ' . $user->get('id'))
                ->where("e.start BETWEEN " . $db->q($neededstart) . " AND " . $db->q($neededend));

        $db->setQuery($query);

        return $db->loadResult();
    }

    public static function getTotalEntrances($cfuserdata) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("COUNT(*)")
                ->from($db->quoteName('#__crossfit_users') . " AS u")
                ->innerJoin($db->quoteName('#__rseventspro_users') . " rs ON rs.idu = u.idUserJoomla")
                ->where("idUser = " . $cfuserdata->idUser)
                ->where("rs.date >= " . $cfuserdata->dataInizioAbbonamento);

        $db->setQuery($query, 0, 1);

        return $db->loadResult();
    }

    public function getMaxEntrances($cfuserdata) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("ingressiTotali")
                ->from($db->quoteName('#__crossfit_subscriptions_users') . " AS us")
                ->innerJoin($db->quoteName('#__crossfit_subscriptions') . " AS s ON s.idSubscription = us.idSubscription")
                ->where($db->qn('idUser') . ' = ' . $cfuserdata->idUser)
                ->order("us.dataInizio DESC");

        $db->setQuery($query, 0, 1);

        return $db->loadResult();
    }

    public function getUserModule() {
        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }
        $cfuserdata = self::getcfuserdata();

        if ($user->get('id') && $cfuserdata) {
            ?>
            <div class='user-info button pull-right'>
                <div>
                    <div>
                        <div class=''>
                            <strong>Salve <?php echo $cfuserdata->nome ?>, le tue scadenze:</strong>
                        </div>
                        <ul>
                            <?php
                            if ($cfuserdata->dataScadenzaCertificato) {
                                $class = 'regular';
                                if (strtotime($cfuserdata->dataScadenzaCertificato) < time()) {
                                    $class = 'expired';
                                } elseif (strtotime($cfuserdata->dataScadenzaCertificato) < time() + (60 * 60 * 24 * 7)) {
                                    $class = 'warning';
                                }
                                ?>
                                <li class='<?php echo $class ?>'>
                                    Certificato medico <i class="fa fa-arrow-right fa-fw"></i> <span><?php echo date("d/m/Y", strtotime($cfuserdata->dataScadenzaCertificato)) ?></span>
                                </li>
                            <?php } ?>
                            <?php
                            if ($cfuserdata->dataScadenzaIscrizione) {
                                $class = 'regular';
                                if (strtotime($cfuserdata->dataScadenzaIscrizione) < time()) {
                                    $class = 'expired';
                                } elseif (strtotime($cfuserdata->dataScadenzaIscrizione) < time() + (60 * 60 * 24 * 7)) {
                                    $class = 'warning';
                                }
                                ?>
                                <li class='<?php echo $class ?>'>
                                    Iscrizione <i class="fa fa-arrow-right fa-fw"></i> <span><?php echo date("d/m/Y", strtotime($cfuserdata->dataScadenzaIscrizione)) ?></span>
                                </li>
                            <?php } ?>
                            <?php
                            if ($cfuserdata->dataScadenzaAbbonamento) {
                                $class = 'regular';
                                if (strtotime($cfuserdata->dataScadenzaAbbonamento) < time()) {
                                    $class = 'expired';
                                } elseif (strtotime($cfuserdata->dataScadenzaAbbonamento) < time() + (60 * 60 * 24 * 7)) {
                                    $class = 'warning';
                                }
                                ?>
                                <li class='<?php echo $class ?>'>
                                    Abbonamento <i class="fa fa-arrow-right fa-fw"></i> <span><?php echo date("d/m/Y", strtotime($cfuserdata->dataScadenzaAbbonamento)) ?></span>
                                </li>
                            <?php } ?>
                        </ul>
                    </div>
                </div>
                <style>
                    ul.scadenzario {line-height: 1.2}
                    ul.scadenzario li.small {font-size: 75%}
                    ul.scadenzario li.success {color: green}
                </style>
                <ul style='width: 100%' class="scadenzario">
                    <?php
                    if (self::get_next_subscription()) {
                        $abbonamentoone = self::get_next_subscription();
                        ?>
                        <li class="small">Il tuo prossimo abbonamento inizierà il <?php echo date("d/m/Y", strtotime($abbonamentoone->dataInizio)) ?> e scadrà il <?php echo strtotime($abbonamentoone->dataScadenzaReale) > 0 ? date("d/m/Y", strtotime($abbonamentoone->dataScadenzaReale)) : date("d/m/Y", strtotime($abbonamentoone->dataScadenzaAbbonamento)) ?></li>
                        <?php
                    }
                    ?>
                    <?php if (!$cfuserdata->dataScadenzaIscrizione) { ?>
                        <li class='expired'>ATTENZIONE: devi effettuare l'iscrizione.</li>
                    <?php } elseif (strtotime($cfuserdata->dataScadenzaIscrizione) < time()) { ?>
                        <li class='expired'>ATTENZIONE: la tua iscrizione è scaduta.</li>
                    <?php } ?>
                    <?php if (!$cfuserdata->dataScadenzaCertificato) { ?>
                        <li class='expired'>ATTENZIONE: consegna il tuo certificato medico.</li>
                    <?php } else if (strtotime($cfuserdata->dataScadenzaCertificato) < time()) { ?>
                        <li class='expired'>ATTENZIONE: il tuo certificato medico è scaduto.</li>
                    <?php } ?>
                    <?php if (!$cfuserdata->abbonamentoSospeso) { ?>
                        <?php if (!$cfuserdata->dataScadenzaAbbonamento) { ?>
                            <li class='expired'>ATTENZIONE: devi effettuare l'abbonamento.</li>
                        <?php } elseif (strtotime($cfuserdata->dataScadenzaAbbonamento) < time()) { ?>
                            <li class='expired'>ATTENZIONE: il tuo abbonamento è scaduto.</li>
                        <?php } ?>
                        <?php if (swypeCrossfitHelper::is_due_untill() && !$cfuserdata->allenamentoAggiuntivo) { ?>
                            <!--li class="small success">Hai a disposizione un ultimo allenamento. Rinnova le tue scadenze al desk.</li-->
                        <?php } elseif (swypeCrossfitHelper::is_due_untill() && $cfuserdata->allenamentoAggiuntivo) { ?>
                            <!--li class="small expired">Hai utilizzato il tuo allenamento aggiuntivo. Rinnova le tue scadenze al desk.</li-->
                        <?php } else { ?>
                            <?php if ($cfuserdata->ad_ingressi) { ?>
                                <?php if ($cfuserdata->arrayIngressi['questa-settimana']['ingressi-disponibili'] > 0) { ?>
                                    <li class='success small'>Hai a disposizione ancora <?php echo $cfuserdata->arrayIngressi['questa-settimana']['ingressi-disponibili'] ?> ingressi per la settimana del <?php echo date("d/m/Y", strtotime($cfuserdata->arrayIngressi['questa-settimana']['data-inizio'])) ?>.</li>
                                <?php } else { ?>
                                    <li class='warning small'>Non hai più ingressi a disposizione per la settimana del <?php echo date("d/m/Y", strtotime($cfuserdata->arrayIngressi['questa-settimana']['data-inizio'])) ?>. Se hai a disposizione dei recuperi puoi utilizzarli per prenotarti fino ad esaurimento.</li>
                                <?php } ?>
                                <?php if ($cfuserdata->arrayIngressi['settimane-future']['ingressi-recuperabili'] > 0) { ?>
                                    <li class='info small'><small>Hai a disposizione <?php echo $cfuserdata->arrayIngressi['settimane-future']['ingressi-recuperabili'] ?> ingressi da recuperare.</small></li>
                                <?php } ?>
                            <?php } elseif ($cfuserdata->adIngressiTotali) { ?>
                                <?php if ($cfuserdata->arrayIngressi['usati'] < $cfuserdata->ingressiTotali) { ?>
                                    <li class='success small'>Hai a disposizione ancora <?php echo $cfuserdata->ingressiTotali - $cfuserdata->arrayIngressi['usati'] ?> ingressi.</li>
                                <?php } else { ?>
                                    <li class='warning small'>Non hai più ingressi a disposizione. Se hai a disposizione dei recuperi puoi utilizzarli per prenotarti fino ad esaurimento.</li>
                                <?php } ?>
                            <?php } ?>
                        <?php } ?>
                    <?php } else { ?>
                        <li class='warning small'>Attenzione: il tuo abbonamento è sospeso.</li>
                    <?php } ?>
                </ul>
                <?php if (JRequest::getVar("debug")) { ?>
                    <pre style="font-size: 9px; text-align: left; padding: 3px;">
                        <?php print_R($cfuserdata) ?>
                    </pre>

                <?php } ?>
            </div>
            <style>
                html body.com-rseventspro.layout-show .user-info {margin-top: 30px;}
            </style>
            <?php
        }
    }

    static function is_due_untill($id = null) {

        if ($id) {
            $db = JFactory::getDbo();

            $query = ""
                    . "SELECT start "
                    . "FROM #__rseventspro_events "
                    . "WHERE id = {$id}";

            $db->setQuery($query);
            $date = strtotime($db->loadResult());
        } else {
            $date = time();
        }
        $cfuser = self::getcfuserdata();

        if (strtotime($cfuser->dataScadenzaAbbonamento) <= $date || strtotime($cfuser->dataScadenzaCertificato) <= $date || strtotime($cfuser->dataScadenzaIscrizione) <= $date) {
            return true;
        }
        return false;
    }

    static function get_event_start_date($id) {
        $db = JFactory::getDbo();

        $query = ""
                . "SELECT start "
                . "FROM #__rseventspro_events "
                . "WHERE id = {$id}";

        $db->setQuery($query);
        return $db->loadResult();
    }

    static function has_class_in_day($ide, $idu = null) {
        if (!$idu) {
            if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
                $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
            } else {
                $user = JFactory::getUser();
            }
            $idu = $user->id;
        }
        $db = JFactory::getDbo();

        $cfuserdata = self::getcfuserdata($idu);

        $query = ""
                . "SELECT COUNT(*) "
                . "FROM #__rseventspro_users "
                . "WHERE idu = {$idu} AND ide IN (SELECT id FROM #__rseventspro_events WHERE DATE(start) = (SELECT DATE(start) FROM #__rseventspro_events WHERE id = {$ide}))";

        $db->setQuery($query);

        return $cfuserdata->ingressiGiornalieri && $db->loadResult() < $cfuserdata->ingressiGiornalieri;
    }

    static function is_subscribed($ide) {
        if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
            $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
        } else {
            $user = JFactory::getUser();
        }
        $idu = $user->id;
        $db = JFactory::getDbo();

        $query = ""
                . "SELECT COUNT(*) "
                . "FROM #__rseventspro_users "
                . "WHERE idu = {$idu} AND ide = {$ide}";

        $db->setQuery($query);

        return $db->loadResult() > 0;
    }

    function isTrainer($id = null) {
        if (!$id) {
            if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
                $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
            } else {
                $user = JFactory::getUser();
            }
        } else {
            $user = JFactory::getUser($id);
        }
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('id')->from($db->quoteName('#__usergroups'))->where("title = 'Trainer'");
        $db->setQuery($query);
        $result = $db->loadObject();

        return in_array($result->id, $user->groups);
    }

    function getTrainerLocation() {
        $user = JFactory::getUser();
        $profile = JUserHelper::getProfile($user->id);

        if ($profile->profile['city']) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select("id")->from("#__rseventspro_locations")->where("LOWER(name) = " . $db->quote(strtolower($profile->profile['city'])));
            $db->setQuery($query);
            $object = $db->loadResult();
            if ($object) {
                return intval($object);
            }
        }

        return false;
    }

}
