<?php
/**
 * @package RSEvents!Pro
 * @copyright (C) 2015 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');
$count = count($this->events);

JHTML::_('behavior.tooltip');

$doc = JFactory::getDocument();
$doc->addStyleSheet('https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700');

if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
    $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
} else {
    $user = JFactory::getUser();
}

setlocale(LC_TIME, "it_IT");

$app = JFactory::getApplication();
$cfuserdata = swypeCrossfitHelper::getcfuserdata();

$palestre = swypeCrossfitHelper::getLocation();
$date = $app->input->getString('date');
if (!$date) {
    $date = date('m-d-Y', strtotime('this week', time()));
}
?>

<h3 style='margin-bottom: 30px; margin-top: 15px'>Dal <?php echo $this->from ?> al <?php echo $this->to ?></h3>


<div class="row rsevents">
    <div class="col-sm-3 col-xs-12 text-left">
        <a href="<?php echo $this->prev; ?>" class="button pull-left"><i class="fa fa-chevron-left"></i> Precedente</a>
        <a href="<?php echo $this->next; ?>" class="button pull-left">Successiva <i class="fa fa-chevron-right"></i></a>
    </div>
    <div class="col-sm-3 col-xs-12 text-center">
        <?php if ((!swypeCrossfitHelper::isTrainer() && !swypeCrossfitHelper::getTrainerLocation()) || (swypeCrossfitHelper::isTrainer() && !swypeCrossfitHelper::getTrainerLocation())) { ?>
            <form name="" action="" method="POST" class="text-center">
                <select name="idPalestra" onchange="this.form.submit();" style="display: table; margin-left: auto; margin-right: auto; width: 50%;">
                    <?php if (swypeCrossfitHelper::isTrainer()) { ?>
                        <option value="" <?php echo (!JRequest::getVar('idPalestra') ? "selected" : null) ?>> - Seleziona il box - </option>
                    <?php } ?>
                    <?php if ($palestre) { ?>
                        <?php foreach ($palestre as $id => $v) { ?>
                            <option value="<?php echo $id ?>" <?php echo (JRequest::getVar('idPalestra') == $id ? "selected" : (!JRequest::getVar('idPalestra') && $cfuserdata->idPalestra == $id ? "selected" : null)) ?>><?php echo $v ?></option>
                        <?php } ?>
                    <?php } ?>
                </select>
                <input type="hidden" name="date" value="<?php echo $date ?>" />
            </form>
            <style>
                @media screen and (max-width: 767px) {
                    select[name='idPalestra'] {
                        margin-top: 15px;
                    }
                }
            </style>
        <?php } ?>
    </div>
    <div class="col-sm-6 col-xs-12 clearfix">
        <?php swypeCrossfitHelper::getUserModule(); ?>
    </div>
</div>


<?php
$eventIds = rseventsproHelper::getEventIds($this->events, 'id');
$daystart = "8";
$dayend = "23";
if ($eventIds) {
    $this->events = rseventsproHelper::details($eventIds);
    if ($this->events) {
        $newEvents = array();
        $newEvents2 = array();
        foreach ($this->events as $event) {
            if (date("H", strtotime($event['event']->start)) < $daystart) {
                $daystart = date("H", strtotime($event['event']->start));
            }
            $newEvents[date("j", strtotime($event['event']->start))][date("Hi", strtotime($event['event']->start))] = $event['event'];
            $newEvents2[date("j", strtotime($event['event']->start))][date("Hi", strtotime($event['event']->start))][$event['event']->id] = $event['event'];
            ksort($newEvents[date("j", strtotime($event['event']->start))]);
        }
    }

    $dayend = false;
    foreach ($newEvents as $h => $evs) {
        foreach ($evs as $ev) {
            if (!$dayend || $dayend < date("H", strtotime($ev->end))) {
                $dayend = date("H", strtotime($ev->end));
            }
        }
    }
    $dayend++;
}

if($dayend < 18) {
    $dayend = 22;
}

$Ndate = str_replace(array('-', ':'), '/', $date);
list($m, $d, $y) = explode('/', $Ndate, 3);

$today = date('Y-m-d 00:00:00', mktime(0, 0, 0, $m, $d, $y));

$startDate = new DateTime($this->startWeek);
$endDate = new DateTime($this->endWeek);

$interval = DateInterval::createFromDateString('1 day');
$periodDays = new DatePeriod($startDate, $interval, $endDate);

$interval = DateInterval::createFromDateString('1 hour');
$periodHours = new DatePeriod(new DateTime(date("Y-m-d {$daystart}:00:00")), $interval, new DateTime(date("Y-m-d {$dayend}:00:00")));

$manyhours = 0;
?>
<div class='sl-calendar'>
    <div class='head'>
        <div class='hidden-xs'></div>
        <?php foreach ($periodDays as $dt) { ?>
            <div class='switch <?php echo ($dt->format("Ymd") == date("Ymd") ? "active" : "") ?>' data-today='<?php echo date("Ymd") ?>' data-time='<?php echo $dt->format("Ymd") ?>'>
                <span class='hidden-xs'><?php echo utf8_encode(ucwords(strftime("%A", $dt->getTimestamp()))); ?></span>
                <span class='hidden-xs'><?php echo utf8_encode(ucwords(strftime("%d %b", $dt->getTimestamp()))); ?></span>
                <span class='visible-xs hidden-sm'><?php echo utf8_encode(ucwords(strftime("%a", $dt->getTimestamp()))); ?></span>
                <span class='visible-xs hidden-sm'><?php echo utf8_encode(ucwords(strftime("%d.%m", $dt->getTimestamp()))); ?></span>
            </div>
        <?php } ?>
    </div>
    <div class='plan'>
        <div class='hours-h hidden-xs'>
            <?php
            foreach ($periodHours as $dh) {
                $manyhours++;
                ?>
                <div><?php echo $dh->format("H:i") ?></div>
            <?php } ?>
        </div>

        <?php foreach ($periodDays as $dt) { ?>
            <div class='day-c <?php echo ($dt->format("Ymd") == date("Ymd") ? "" : " hidden-xs") ?>' data-time='<?php echo $dt->format("Ymd") ?>'>
                <?php foreach ($periodHours as $dh) { ?>
                    <div class='hidden-xs'></div>
                <?php } ?>
                <?php if ($newEvents2[$dt->format("j")]) { ?>
                    <?php
                    if ($newEvents2) {
                        foreach ($newEvents2[$dt->format("j")] as $h => $id) {
                            $conteggiow = -1;
                            $conteggiodim = count($newEvents2[$dt->format("j")][$h]);
                            foreach ($id as $event) {
                                $conteggiow++;
                                //echo $this->usercat.print_r($event->category_key);exit;
                                if ($user->get('id') && $this->usercat == 'elements' && in_array('crossfit/no elements', $event->category_key)) {
                                    continue;
                                }

                                $counterAfter = 0;
                                $counterBefore = 0;
                                $to_time = strtotime($event->start);
                                $from_time = strtotime($event->end);
                                $duration = round(abs($to_time - $from_time) / 60, 2);
                                $height = "calc(((100% / {$manyhours}) / 60) * " . ($duration) . ")";
                                $top = "calc((100% / {$manyhours}) * " . ((int) date("H", strtotime($event->start)) - $daystart) . " + (((100% / {$manyhours}) / 60) * " . ((int) date("i", strtotime($event->start))) . "))";
                                if (count($newEvents2[$dt->format("j")]) > 1) {
                                    foreach ($newEvents2[$dt->format("j")] as $h => $newevent) {
                                        if ($event == $newevent) {
                                            continue;
                                        }
                                        if ($event->start >= $newevent->start && $event->start <= $newevent->end) {
                                            $counterBefore++;
                                        }
                                        if ($event->start <= $newevent->start && $event->end >= $newevent->start) {
                                            $counterAfter++;
                                        }
                                    }
                                }

                                $css = "";
                                $css .= "top: {$top};";
                                $css .= "height: {$height};";
                                $css .= "max-height: {$height};";
                                $css .= "z-index: " . ($conteggiodim) . ";";
                                $css .= "width: calc(100% / " . ($conteggiodim) . ");";
                                $css .= "margin-left: calc((100% / " . ($conteggiodim) . ") * " . ($conteggiow) . ");";

                                if ($event->color) {
                                    $hex = str_replace("#", "", $event->color);

                                    if (strlen($hex) == 3) {
                                        $r = hexdec(substr($hex, 0, 1) . substr($hex, 0, 1));
                                        $g = hexdec(substr($hex, 1, 1) . substr($hex, 1, 1));
                                        $b = hexdec(substr($hex, 2, 1) . substr($hex, 2, 1));
                                    } else {
                                        $r = hexdec(substr($hex, 0, 2));
                                        $g = hexdec(substr($hex, 2, 2));
                                        $b = hexdec(substr($hex, 4, 2));
                                    }
                                    $rgb = array($r, $g, $b);
                                    $css .= "background: rgba({$r}, {$g}, {$b}, .45);";
                                    $css .= "border: 1px solid rgba(0,0,0,.15);";
                                }
                                $classPassed = (strtotime($event->start) < time() ? " passed" : "");

                                $tooltiptext = "<div class='hidden-xs' style='font-size: 13px; text-shadow: none; font-family: Open Sans, Arial, sans-serif'><b style='font-size: 15px'>" . $event->name . "</b><br>" . date("H:i", strtotime($event->start)) . " - " . date("H:i", strtotime($event->end)) . "";
                                if ($event->max_tickets_amount) {
                                    $tooltiptext .= "<div style='width: 100%; text-align: center; color: black; background: white; padding: 3px; margin-top: 5px; box-sizing: border-box; font-size: 20px; font-weight: bold;'>" . ($event->subscribers) . " / {$event->max_tickets_amount}</div>";
                                    $tooltiptext .= "<div style='width: 100%; text-align: center; color: white; margin-top: 5px; box-sizing: border-box'>" . ($event->max_tickets_amount - $event->subscribers) . " disponbili</div>";
                                }
                                $tooltiptext .= "</div>";
                                ?>
                                <section class='event hasTooltip hidden-xs <?php echo ($counterBefore ? "hasBefore" : "") ?><?php echo ($counterAfter ? "hasAfter" : "") ?><?php echo $classPassed ?> <?php echo (!swypeCrossfitHelper::isTrainer() && swypeCrossfitHelper::is_subscribed($event->id) ? "subscribed" : "" ) ?>' style='<?php echo $css ?>' data-html='true' data-original-title="<?php echo $tooltiptext ?>">
                                    <div class=''  >
                                        <a href='<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=show&id=' . rseventsproHelper::sef($event->id, $event->name), false, rseventsproHelper::itemid($event->id)); ?>'>
                                            <span><?php echo date("H:i", strtotime($event->start)) ?> - <?php echo date("H:i", strtotime($event->end)) ?></span>
                                            <div class='clearfix'>
                                                <h3 class='pull-left'><?php echo $event->name ?></h3>
                                            </div>
                                            <?php if (!swypeCrossfitHelper::isTrainer() && swypeCrossfitHelper::is_subscribed($event->id)) { ?>
                                                <span class="check-container"><i class="fa fa-check"></i></span>
                                            <?php } ?>
                                        </a>
                                    </div>
                                </section>
                                <section class='event visible-xs <?php echo ($counterBefore ? "hasBefore" : "") ?><?php echo ($counterAfter ? "hasAfter" : "") ?><?php echo $classPassed ?> <?php echo (!swypeCrossfitHelper::isTrainer() && swypeCrossfitHelper::is_subscribed($event->id) ? "subscribed" : "" ) ?>' style='<?php echo $css ?>'>
                                    <div class=''  >
                                        <a href='<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=show&id=' . rseventsproHelper::sef($event->id, $event->name), false, rseventsproHelper::itemid($event->id)); ?>'>
                                            <span class=>
                                                <?php echo date("H:i", strtotime($event->start)) ?> - <?php echo date("H:i", strtotime($event->end)) ?>
                                                <span class='pull-right vacancy visible-xs'>
                                                    <?php if (swypeCrossfitHelper::isTrainer()) { ?>
                                                        <?php echo ($event->subscribers) ?> iscritti
                                                    <?php } else { ?>
                                                        <?php echo ($event->max_tickets_amount - $event->subscribers) ?> posti disponbili
                                                    <?php } ?>
                                                </span>
                                            </span>
                                            <div class='clearfix'>
                                                <h3 class='pull-left'><?php echo $event->name ?></h3>
                                            </div>
                                            <?php if (!swypeCrossfitHelper::isTrainer() && swypeCrossfitHelper::is_subscribed($event->id)) { ?>
                                                <span class="check-container"><i class="fa fa-check"></i></span>
                                            <?php } ?>
                                            <p class='right'>Visualizza</p>
                                        </a>
                                    </div>
                                </section>
                                <?php
                            }
                        }
                    }
                    ?>
                <?php } ?>
            </div>
        <?php } ?>
    </div>
</div>

<script>
    jQuery(function ($) {
        $.noConflict();
        if ($(".sl-calendar .head .switch.active").size() == 0) {
            var data = $(".sl-calendar .head .switch:not(.active)").first().data("time");
            $(".sl-calendar .head .switch:not(.active)").first().addClass("active");
            $(".sl-calendar .plan .day-c[data-time='" + data + "']").removeClass("hidden-xs");
        }
        $('.hasTooltip').tooltip().on('hidden.bs.tooltip', function (e) {
            $(this).css("display", "block!important");
        });
        $(document).on("touchstart", ".sl-calendar .head .switch:not(.active)", function () {
            $(".sl-calendar .head .switch.active").removeClass("active");
            $(this).addClass("active");
            $(".sl-calendar .plan .day-c[data-time!='" + $(this).data("time") + "']").addClass("hidden-xs");
            $(".sl-calendar .plan .day-c[data-time='" + $(this).data("time") + "']").removeClass("hidden-xs");
        });
    });
</script>