<?php
/**
 * @package RSEvents!Pro
 * @copyright (C) 2015 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.modal', '.rs_modal');

$doc = JFactory::getDocument();
$doc->addStyleSheet('https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700');

$details = rseventsproHelper::details($this->event->id);
$event = $details['event'];
$categories = $details['categories'];
$tags = $details['tags'];
$files = $details['files'];
$repeats = $details['repeats'];
$full = rseventsproHelper::eventisfull($this->event->id);
$ongoing = rseventsproHelper::ongoing($this->event->id);
$featured = $event->featured ? ' rs_featured_event' : '';

$cfuserdata = swypeCrossfitHelper::getcfuserdata();

$datafineEvento = strtotime($event->end);

/* * *************************************************************** */

$possoiscrivermi = true;
/*
 * Non posso iscrivermi se:
 * - Ho le scadenze minori della data dell'evento
 */
if (swypeCrossfitHelper::is_due_untill($event->id)) {
    /*
     * - Se ho delle scadenze passate e ho usufruito dell'abbonamento aggiuntivo
      if ($cfuserdata->allenamentoAggiuntivo) {
      $possoiscrivermi = false;
      $motivo = "(#01) Hai usufruito dell'allenamento aggiuntivo: controlla le tue scadenze!";
      }
     */
    $possoiscrivermi = false;
    $motivo = "(#01) Il tuo abbonamento è scaduto!";
} else {
    if ($cfuserdata->abbonamentoSospeso) {
        /*
         * - Se ho l'abbonamento sospeso
         */
        $possoiscrivermi = false;
        $motivo = "(#08) Hai l'abbonamento sospeso.";
        /*
         * - Se ho l'abbonamento ad ingressi settimanali
         */
    } elseif ($cfuserdata->ad_ingressi) {
        if (!swypeCrossfitHelper::has_class_in_day($event->id)) {
            $possoiscrivermi = false;
            if ($cfuserdata->ingressiGiornalieri > 1) {
                $motivo = "(#05) Ti sei già registrato a {$cfuserdata->ingressiGiornalieri} classi in data " . date("d-m-Y", strtotime($event->start)) . ".";
            } else {
                $motivo = "(#05) Ti sei già registrato ad {$cfuserdata->ingressiGiornalieri} classe in data " . date("d-m-Y", strtotime($event->start)) . ".";
            }
        } else if ($cfuserdata->arrayIngressi['questa-settimana']['ingressi-disponibili'] <= 0) {
            if ($cfuserdata->arrayIngressi['settimane-future']['ingressi-recuperabili'] <= 0) {
                $possoiscrivermi = false;
                $motivo = "(#03) Hai usufruito di tutti gli allenamenti disponibili questa settimana e non hai recuperi da effettuare.";
            }
        }
        /*
         * - Se ho l'abbonamento ad ingressi totali
         */
    } elseif ($cfuserdata->adIngressiTotali) {
        /*
         * - e ho usufruito di tutti gli ingressi possibili
         */
        if ($cfuserdata->arrayIngressi['usati'] >= $cfuserdata->ingressiTotali) {
            $possoiscrivermi = false;
            $motivo = "(#04) Hai usufruito di tutti gli allenamenti disponibili per il tuo abbonamento.";
        }
    }
}


if (!$cfuserdata->dataScadenzaIscrizione || $cfuserdata->dataScadenzaIscrizione == '0000-00-00 23:59:59') {
    $possoiscrivermi = false;
    $motivo = "(#09) Non puoi registrarti: devi effettuare l'iscrizione";
} elseif (strtotime($cfuserdata->dataScadenzaIscrizione) < strtotime($event->start)) {
    $possoiscrivermi = false;
    $motivo = "(#08) Non puoi registrarti: la tua iscrizione è scaduta";
}

if (!$cfuserdata->dataScadenzaCertificato || $cfuserdata->dataScadenzaCertificato == '0000-00-00 23:59:59') {
    $possoiscrivermi = false;
    $motivo = "(#09) Non puoi registrarti: devi consegnre il certificato medico";
} elseif (strtotime($cfuserdata->dataScadenzaCertificato) < strtotime($event->start)) {
    $possoiscrivermi = false;
    $motivo = "(#08) Non puoi registrarti: il tuo certificato medico è scaduto";
}

/*
if (swypeCrossfitHelper::has_class_in_day($this->event->id)) {
    $possoiscrivermi = false;
    if ($cfuserdata->ingressiGiornalieri > 1) {
        $motivo = "(#05) Ti sei già registrato a {$cfuserdata->ingressiGiornalieri} classi in data " . date("d-m-Y", strtotime($event->start)) . ".";
    } else {
        $motivo = "(#05) Ti sei già registrato ad {$cfuserdata->ingressiGiornalieri} classe in data " . date("d-m-Y", strtotime($event->start)) . ".";
    }
}
*/

if ($event->end_registration != '0000-00-00 00:00:00' && time() > strtotime($event->end_registration)) {
    $possoiscrivermi = false;
    $motivo = "(#06) Non puoi più registrarti alla classe.";
}

if (time() < strtotime("- {$this->dispatchDays} days", strtotime($event->start))) {
    $possoiscrivermi = false;
    $timing = (strtotime("- {$this->dispatchDays} days", strtotime($event->start)) - time());
    $motivo = "(#07) Puoi iscriverti a questa classe tra " . gmdate("j", $timing) . " giorni, " . gmdate("H", $timing) . " ore, " . gmdate("i", $timing) . " minuti e " . gmdate("s", $timing) . " secondi";
}

$checkscadenza = ((strtotime($event->end) <= strtotime($cfuserdata->dataScadenzaAbbonamento) && strtotime($event->end) <= strtotime($cfuserdata->dataScadenzaCertificato) && strtotime($event->end) <= strtotime($cfuserdata->dataScadenzaIscrizione)) || !$cfuserdata->allenamentoAggiuntivo);


if (swypeCrossfitHelper::is_administrator() && swypeCrossfitHelper::get_debugged_user()) {
    $user = JFactory::getUser(swypeCrossfitHelper::get_debugged_user());
} else {
    $user = JFactory::getUser();
}
?>


<?php swypeCrossfitHelper::getUserModule(); ?>

<!-- Initialize map -->
<?php if (!empty($this->options['show_map']) && !empty($event->coordinates) && rseventsproHelper::getConfig('enable_google_maps', 'int')) { ?>
    <script type="text/javascript">
        var rseproeventmap;
        jQuery(document).ready(function () {
            rseproeventmap = jQuery('#map-canvas').rsjoomlamap({
                zoom: <?php echo (int) $this->config->google_map_zoom ?>,
                center: '<?php echo $this->config->google_maps_center; ?>',
                markerDraggable: false,
                markers: [
                    {
                        title: '<?php echo addslashes($event->name); ?>',
                        position: '<?php echo $this->escape($event->coordinates); ?>',
                        content: '<div id="content"><b><?php echo addslashes($event->name); ?></b> <br /> <?php echo JText::_('COM_RSEVENTSPRO_LOCATION_ADDRESS', true); ?>: <?php echo addslashes($event->address); ?> <?php if (!empty($event->locationlink)) echo '<br /><a target="_blank" href="' . addslashes($event->locationlink) . '">' . addslashes($event->locationlink) . '</a></div>'; ?>'
                    }
                ]
            });
        });
    </script>
<?php } ?>
<!--//end Initialize map-->

<?php
$links = rseventsproHelper::getConfig('modal', 'int');
$class = '';
$rel_s = '';
$rel_i = '';
$rel_g = '';

if ($links == 2)
    $class = ' rs_modal';
if ($links == 1)
    $rel_s = ' rel="rs_subscribe"';
else if ($links == 2)
    $rel_s = ' rel="{handler: \'iframe\',size: {x:' . $this->modal_width . ',y:' . $this->modal_height . '}}"';
if ($links == 1)
    $rel_i = ' rel="rs_invite"';
else if ($links == 2)
    $rel_i = ' rel="{handler: \'iframe\',size: {x:' . $this->modal_width . ',y:' . $this->modal_height . '}}"';
if ($links == 1)
    $rel_g = ' rel="rs_message"';
else if ($links == 2)
    $rel_g = ' rel="{handler: \'iframe\',size: {x:' . $this->modal_width . ',y:' . $this->modal_height . '}}"';
$tmpl = $links == 0 ? '' : '&tmpl=component';
?>
<?php JFactory::getApplication()->triggerEvent('rsepro_onBeforeEventDisplay', array(array('event' => &$event, 'categories' => &$categories, 'tags' => &$tags))); ?>
<script type="application/ld+json">
    {
    "@context": "http://schema.org",
    "@type": "Event",
    "name": "<?php echo $this->escape($event->name); ?>",
    "startDate" : "<?php echo rseventsproHelper::showdate($event->start, 'Y-m-d H:i:s'); ?>",
    <?php if (!$event->allday) { ?>"endDate" : "<?php echo rseventsproHelper::showdate($event->end, 'Y-m-d H:i:s'); ?>",<?php } ?>
    "url" : "<?php echo $this->root . rseventsproHelper::route('index.php?option=com_rseventspro&layout=show&id=' . rseventsproHelper::sef($event->id, $event->name), false, rseventsproHelper::itemid($event->id)); ?>",
    "image" : "<?php echo $this->escape($this->root . $details['image_b']); ?>",
    "description": "<?php echo strip_tags($event->description); ?>",
    "location" :
    {
    "@type" : "Place",
    "name" : "<?php echo $this->escape($event->location); ?>",
    "address" :
    {
    "@type" : "PostalAddress",
    "name" : "<?php echo $this->escape($event->address); ?>"
    }
    }
    }
</script>

<div id="rs_event_show">

    <div class='clearfix' style='padding-top: 30px'>
        <?php
        if (date("N", strtotime($event->start)) != 1) {
            $date = date('m-d-Y', strtotime("last monday", strtotime($event->start)));
        } else {
            $date = date('m-d-Y', strtotime($event->start));
        }
        ?>
        <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&view=calendar&layout=week&date=' . $date . '&Itemid=139') ?>" class="button pull-left"><i class="fa fa-chevron-left"></i> Torna alle classi della settimana</a>
    </div>

    <div class="rs_image rsevents clearfix" style='display: flex; align-items: center;'>
        <div class='date'>
            <span><?php echo rseventsproHelper::showdate($event->start, 'd'); ?></span>
            <span><?php echo JFactory::getDate($event->start)->format('F') ?></span>
        </div>
        <div>
            <h1 style="margin-top: 0;" class="<?php echo $full ? ' rs_event_full' : ''; ?><?php echo $ongoing ? ' rs_event_ongoing' : ''; ?><?php echo $featured; ?>"><?php echo $this->escape($event->name); ?></h1>
            <div class="orario" style="margin-bottom: 5px;">
                Dalle <b><?php echo rseventsproHelper::showdate($event->start, 'H:i'); ?></b> alle <b><?php echo rseventsproHelper::showdate($event->end, 'H:i'); ?></b>
            </div>
            <?php if ($event->location) { ?>
                <div class=''><b>Box</b>: <?php echo $event->location ?></div>
            <?php } ?>
            <?php if ($event->max_tickets_amount) { ?>
                <div class=''><b>Posti disponibili</b>: <?php echo $event->max_tickets_amount - $event->subscribers ?> / <?php echo $event->max_tickets_amount ?></div>
            <?php } ?>
        </div>
        <div class='button-iscritto-container'>
            <?php if ($this->istrainer) { ?>
                <?php if (!$this->eventended) { ?>
                    <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=subscribe&id=' . rseventsproHelper::sef($event->id, $event->name) . $tmpl); ?>" class="button small <?php echo $class; ?>"<?php echo $rel_s; ?> >
                        <i class="fa fa-plus fa-fw"></i> Aggiungi iscrizione
                    </a>
                <?php } ?>
            <?php } else if (!$this->eventended) { ?>
                <?php if ($this->issubscribed) { ?>
                    <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&task=rseventspro.unsubscribe&id=' . rseventsproHelper::sef($event->id, $event->name)); ?>" class="button special ">
                        <i class="fa fa-times fa-fw"></i> <?php echo JText::_('COM_RSEVENTSPRO_EVENT_UNSUBSCRIBE'); ?>
                    </a>
                <?php } elseif ($cfuserdata && $this->cansubscribe['status']) { ?>
                    <?php if (!$possoiscrivermi) { ?>
                        <span class="button special danger" style="width: auto; max-width: 250px; display: inline-block;">
                            <i class="fa fa-times fa-fw"></i> <?php echo $motivo ?>
                        </span>
                    <?php } else { ?>
                        <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&layout=subscribe&id=' . rseventsproHelper::sef($event->id, $event->name) . $tmpl); ?>" class="button special <?php echo $class; ?>"<?php echo $rel_s; ?> >
                            <i class="fa fa-check fa-fw"></i> <?php echo "Partecipa alla classe"; ?>
                        </a>
                    <?php } ?>
                <?php } elseif (!$cfuserdata) { ?>
                    <a href="javascript:void(0)" class="button special danger">
                        <i class="fa fa-times fa-fw"></i> Devi essere loggato per iscriverti alla classe.
                    </a>
                <?php } ?>
            <?php } ?>
        </div>
    </div>

    <!-- Event Title -->

    <!--//end Event Title -->


    <div class="rs_clear"></div>
    <!-- Description -->
    <?php if (!empty($this->options['show_description']) && !empty($event->description)) { ?>
        <span class="description"><?php echo $event->description; ?></span>
        <div class="rs_clear"></div>
    <?php } ?>
    <!--//end Description -->

    <!-- Show subscribers -->
    <?php if (swypeCrossfitHelper::isTrainer()) { ?>
        <?php if (!empty($this->guests)) { ?>
            <h3><?php echo JText::_('Iscritti'); ?></h3>
            <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&task=rseventspro.exportguests&id=' . rseventsproHelper::sef($this->event->id, $this->event->name)); ?>"><?php echo JText::_('Esporta iscritti'); ?></a> <br />
            <div class="rs_clear"></div>
            <ul class="rs_events_container">
                <?php
                foreach ($this->guests as $guest) {
                    if ($guest->state == 2)
                        continue;
                    ?>
                    <li class="rs_event_detail rs_subscription">
                        <div class="rs_options" style="display:none;">
                            <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&task=rseventspro.approve&id=' . rseventsproHelper::sef($guest->id, $guest->name)); ?>" title="<?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_APPROVE'); ?>">
                                <i class="fa fa-check fa-fw"></i>
                            </a>
                            <a href="<?php echo rseventsproHelper::route('index.php?option=com_rseventspro&task=rseventspro.denied&id=' . rseventsproHelper::sef($guest->id, $guest->name)); ?>" title="<?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_DENIED'); ?>">
                                <i class="fa fa-minus-circle fa-fw"></i>
                            </a>
                        </div>
                        <div class="rs_event_details rs_inline">
                            <?php echo $guest->name; ?><br>
                            <?php echo $guest->email; ?>
                        </div>
                        <div class="rs_status"><?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_STATUS'); ?>: <?php echo $this->getStatus($guest->state); ?></div>
                    </li>
                <?php } ?>
            </ul>
            <div class="rs_clear"></div>
        <?php } ?>
    <?php } ?>
    <!--//end Show subscribers -->

    <?php JFactory::getApplication()->triggerEvent('rsepro_onAfterEventDisplay', array(array('event' => $event, 'categories' => $categories, 'tags' => $tags))); ?>

    <!-- Comments -->
    <?php if ($event->comments) { ?>
        <div class="rs_comments">
            <?php echo rseventsproHelper::comments($event->id, $event->name); ?>
        </div>
        <div class="rs_clear"></div>
    <?php } ?>
    <!--//end Comments -->

    <?php if (($event->comments && rseventsproHelper::getConfig('event_comment', 'int') == 1) || !empty($this->options['enable_fb_like'])) { ?>
        <div id="fb-root"></div>
        <script type="text/javascript">
            (function (d, s, id) {
                var js, fjs = d.getElementsByTagName(s)[0];
                if (d.getElementById(id))
                    return;
                js = d.createElement(s);
                js.id = id;
                js.src = "//connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.4&appId=<?php echo $this->escape(rseventsproHelper::getConfig('facebook_app_id')); ?>";
                fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));
        </script>
    <?php } ?>
</div>

<?php if ($this->config->timezone) { ?>
    <div id="timezoneModal" class="modal hide fade" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
            <h3><?php echo JText::_('COM_RSEVENTSPRO_CHANGE_TIMEZONE'); ?></h3>
        </div>
        <div class="modal-body">
            <form method="post" action="<?php echo htmlentities(JUri::getInstance(), ENT_COMPAT, 'UTF-8'); ?>" id="timezoneForm" name="timezoneForm" class="form-horizontal">
                <div class="control-group">
                    <div class="control-label">
                        <label><?php echo JText::_('COM_RSEVENTSPRO_DEFAULT_TIMEZONE'); ?></label>
                    </div>
                    <div class="controls">
                        <span class="btn disabled"><?php echo $this->timezone; ?></span>
                    </div>
                </div>
                <div class="control-group">
                    <div class="control-label">
                        <label for="timezone"><?php echo JText::_('COM_RSEVENTSPRO_SELECT_TIMEZONE'); ?></label>
                    </div>
                    <div class="controls">
                        <?php echo JHtml::_('rseventspro.timezones', 'timezone'); ?>
                    </div>
                </div>
                <input type="hidden" name="task" value="timezone" />
                <input type="hidden" name="return" value="<?php echo $this->timezoneReturn; ?>" />
            </form>
        </div>
        <div class="modal-footer">
            <button class="btn" data-dismiss="modal" aria-hidden="true"><?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_CANCEL'); ?></button>
            <button class="btn btn-primary" type="button" onclick="document.timezoneForm.submit();"><?php echo JText::_('COM_RSEVENTSPRO_GLOBAL_SAVE'); ?></button>
        </div>
    </div>
<?php } ?>
<style>
    @media screen and (max-width: 767px) {
        .button-iscritto-container {
            float: none !important;
            margin-top: 15px !important;
            width: 100% !important;
            max-width: 100% !important;
        }
    }
</style>